﻿package de.davidochmann.games.crashlines
{
	/**
	 * @author dochmann
	 */
	import com.greensock.easing.Strong;	
	import com.greensock.TweenMax;	
	
	import flash.events.MouseEvent;	
	import flash.events.Event;	
	import flash.display.Sprite;	

	public class CrashLines extends Sprite 
	{
		private static var GAME_WIDTH:uint = 800;
		private static var GAME_HEIGHT:uint = 600;
		
		private var mGameBackground:GameBackground;
		private var mGameContainer:Sprite;
		private var mGameMenu:GameMenu;
		private var mGame:Game;

		public function CrashLines():void
		{
			initBackground();
			//initIntro();
			initGameContainer();
			initMenu();	
			addChildren();
		}
		
		private function initBackground():void
		{
			mGameBackground = new GameBackground(GAME_WIDTH, GAME_HEIGHT);	
		}

		private function initMenu():void
		{
			mGameMenu = new GameMenu(GAME_WIDTH, GAME_HEIGHT);
			mGameContainer.addChild(mGameMenu);
		
			TweenMax.from(mGameMenu, 1, {alpha:0, ease:Strong.easeOut});
		
			initButtonEventHandler();	
		}

		private function initButtonEventHandler():void
		{
			mGameMenu.getGraphicHighButton().addEventListener(MouseEvent.MOUSE_UP, graphicHighUpHandler);
			mGameMenu.getGraphicLowButton().addEventListener(MouseEvent.MOUSE_UP, graphicLowUpHandler);			
		}

		private function clearButtonEventHandler():void
		{
			mGameMenu.getGraphicHighButton().removeEventListener(MouseEvent.MOUSE_UP, graphicHighUpHandler);
			mGameMenu.getGraphicLowButton().removeEventListener(MouseEvent.MOUSE_UP, graphicLowUpHandler);			
		}

		private function graphicHighUpHandler(e:MouseEvent):void
		{
			clearButtonEventHandler();
			mGame = new Game(stage, GAME_WIDTH, GAME_HEIGHT, Game.GRAPHIC_HIGH);
			
			TweenMax.from(mGame, 1, {alpha:0, ease:Strong.easeOut});
			TweenMax.to(mGameMenu, 1, {alpha:0, ease:Strong.easeOut, onComplete:addGame});						
		}
		
		private function graphicLowUpHandler(e:MouseEvent):void
		{
			clearButtonEventHandler();	
			mGame = new Game(stage, GAME_WIDTH, GAME_HEIGHT, Game.GRAPHIC_LOW);
			
			TweenMax.from(mGame, 1, {alpha:0, ease:Strong.easeOut});
			TweenMax.to(mGameMenu, 1, {alpha:0, ease:Strong.easeOut, onComplete:addGame});
		}

		
		private function addGame():void
		{
			mGameContainer.removeChild(mGameMenu);
			mGameContainer.addChild(mGame);
		}

		
		private function initGameContainer():void
		{
			mGameContainer = new Sprite();
		}

		
		private function addChildren():void
		{
			addChild(mGameBackground);
			addChild(mGameContainer);	
		}
	}
}
