package de.davidochmann.games.crashlines 
{
	/**
	 * @author dochmann
	 */
	import flash.geom.Matrix;	
	import flash.display.GradientType;	
	import flash.display.Graphics;	
	import flash.display.Sprite;

	public class GameBackground extends Sprite 
	{
		private static var BORDER_COLOR:uint = 0xCCCCCC;
		
		private var mGameWidth:uint;
		private var mGameHeight:uint;
		
		private var mBackground:Sprite;
		
		public function GameBackground(pGameWidth:uint, 
									   pGameHeight:uint)
		{
			setGameWidth(pGameWidth);
			setGameHeight(pGameHeight);
			
			initBackground();
			addChildren();
		}
		
		
		public function getGameWidth():uint
		{
			return mGameWidth;
		}

		public function getGameHeight():uint
		{
			return mGameHeight;
		}
		
		
		public function setGameWidth(pGameWidth:uint):void
		{
			mGameWidth = pGameWidth;
		}

		public function setGameHeight(pGameHeight:uint):void
		{
			mGameHeight = pGameHeight;
		}
		
		
		private function initBackground():void
		{
			mBackground = new Sprite();
			
			var radialWidth:uint = 10000;
			var radialHeight:uint = radialWidth;
			var canvas:Graphics = mBackground.graphics;
			var fillType:String = GradientType.RADIAL;
			var colors:Array = [0xFFFFFF, 0xEEEEEEE];
			var alphas:Array = [1, 1];
			var ratios:Array = [0x00, 0xFF];
			var matrix:Matrix = new Matrix();

			matrix.createGradientBox(radialWidth, radialHeight, 0, mGameWidth * .5 - radialWidth * .5, mGameHeight * .5 - radialHeight * .5);
  						
			canvas.beginGradientFill(fillType, colors, alphas, ratios, matrix);  
			canvas.drawRect(0, 0, mGameWidth, mGameHeight);
			canvas.endFill();
			
			canvas.beginFill(BORDER_COLOR);
			canvas.drawRect(0             , 0             , mGameWidth , 1          );
			canvas.drawRect(mGameWidth - 1, 0             , 1          , mGameHeight);
			canvas.drawRect(0             , 0             , 1          , mGameHeight);
			canvas.drawRect(0             , mGameHeight - 1, mGameWidth, 1          );
			canvas.endFill();		
		}
		
		private function addChildren():void
		{
			addChild(mBackground);
		}
	}
}
