package de.davidochmann.games.crashlines 
{
	/**
	 * @author dochmann
	 */
	import flash.filters.DropShadowFilter;	
	import flash.events.Event;
	import gs.easing.Elastic;	
	import gs.TweenMax;			
	import flash.display.Sprite;	
	import de.davidochmann.lib.graphics.DoLogo;	
	
	public class GameIntro extends Sprite
	{
		public static var INTRO_COMPLETE:String = "INTRO_COMPLETE";
		private static var LOGO_SIZE:uint = 200;
	
		private var mGameWidth:uint;
		private var mGameHeight:uint;
		
		private var mShadow:DropShadowFilter;
		private var mDoLogo:Sprite;

		public function GameIntro(pGameWidth:uint,
								  pGameHeight:uint):void
		{
			setGameWidth(pGameWidth);
			setGameHeight(pGameHeight);
			
			initShadow();
			initDoLogo();
			initAnimation();
			
			addChildren();			
		}

		
		public function getGameWidth():uint
		{
			return mGameWidth;
		}

		public function getGameHeight():uint
		{
			return mGameHeight;
		}
		
		
		public function setGameWidth(pGameWidth:uint):void
		{
			mGameWidth = pGameWidth;
		}

		public function setGameHeight(pGameHeight:uint):void
		{
			mGameHeight = pGameHeight;
		}

		private function initShadow():void
		{
			mShadow = new DropShadowFilter(5, 45., 0x000000, .6, 10, 10, 1, 1, false, false, false);
		}

		private function initDoLogo():void
		{
			mDoLogo = new Sprite();
			
			var logo:DoLogo = new DoLogo(LOGO_SIZE);
						
			logo.x = - LOGO_SIZE * .5;
			logo.y = - LOGO_SIZE * .5;
			logo.filters = [mShadow];

			mDoLogo.addChild(logo);
			
			mDoLogo.x = mGameWidth * .5;
			mDoLogo.y = mGameHeight * .5; 
		}

		
		private function initAnimation():void
		{
			TweenMax.from(mDoLogo, 2, {delay:1, alpha:0, rotation:-30, scaleX:2, scaleY:2, ease:Elastic.easeOut});
			TweenMax.to(mDoLogo, 1, {delay:5, alpha:0, onComplete:dispatchCompleteEvent});
		}

		private function dispatchCompleteEvent():void
		{
			dispatchEvent(new Event(INTRO_COMPLETE));
		}

		
		private function addChildren():void
		{
			addChild(mDoLogo);
		}
	}
}
