﻿package de.davidochmann.games.crashlines 
{
	
	/**
	 * @author dochmann
	 */
	 
	import com.greensock.TweenMax;
	import flash.events.MouseEvent;	 
	import flash.filters.DropShadowFilter;	
	import flash.display.Sprite;
	 
	public class GameMenu extends Sprite 
	{
		private var mDropShadow:DropShadowFilter;
		private var mBackground:Sprite;
		private var mLogo:Sprite;
		private var mGraphicLowButton:Sprite;
		private var mGraphicHighButton:Sprite;
		
		private var mGameWidth:uint;
		private var mGameHeight:uint;
		
		
		public function GameMenu(pGameWidth:uint,
								 pGameHeight:uint)
		{
			setGameWidth(pGameWidth);
			setGameHeight(pGameHeight);
			
			initShadow();
			initBackground();
			initLogo();
			initGraphicLowButton();
			initGraphicHighButton();
			addChildren();
		}
		
		
		public function getGraphicLowButton():Sprite
		{
			return mGraphicLowButton;
		}

		public function getGraphicHighButton():Sprite
		{
			return mGraphicHighButton;
		}

		
		public function getGameWidth():uint
		{
			return mGameWidth;
		}

		public function getGameHeight():uint
		{
			return mGameHeight;
		}
		
		
		public function setGameWidth(pGameWidth:uint):void
		{
			mGameWidth = pGameWidth;
		}

		public function setGameHeight(pGameHeight:uint):void
		{
			mGameHeight = pGameHeight;
		}
		

		private function initShadow():void
		{
			mDropShadow = new DropShadowFilter(0, 45., 0x000000, .6, 10, 10, 1, 1, false, false, false);
		}
		
		private function initBackground():void
		{
			mBackground = GraphicContainer.getInstance().mMenuBackground;
			
			mBackground.x = Math.floor(mGameWidth * .5 - mBackground.width * .5);
			mBackground.y = Math.floor(mGameHeight * .5 - mBackground.height * .5);
		}

		private function initLogo():void
		{
			mLogo = GraphicContainer.getInstance().mCrashLines;
			
			mLogo.x = Math.floor(mGameWidth * .5 - mLogo.width * .5);
			mLogo.y = Math.floor(mGameHeight * .5 - mLogo.height * .5 - 70);
		}
		
		private function initGraphicLowButton():void
		{
			mGraphicLowButton = GraphicContainer.getInstance().mGraphicLow;
			
			mGraphicLowButton.buttonMode = true;
		
			mGraphicLowButton.addEventListener(MouseEvent.MOUSE_OVER, graphicButtonOverHandler);
			mGraphicLowButton.addEventListener(MouseEvent.MOUSE_OUT, graphicButtonOutHandler);
			
			mGraphicLowButton.x = Math.floor(mGameWidth * .5 - mGraphicLowButton.width * .5);
			mGraphicLowButton.y = Math.floor(mGameHeight * .5 - mGraphicLowButton.height * .50 + 100);
		}

		private function initGraphicHighButton():void
		{
			mGraphicHighButton = GraphicContainer.getInstance().mGraphicHigh;

			mGraphicHighButton.buttonMode = true;
			
			mGraphicHighButton.addEventListener(MouseEvent.MOUSE_OVER, graphicButtonOverHandler);
			mGraphicHighButton.addEventListener(MouseEvent.MOUSE_OUT, graphicButtonOutHandler);
		
			mGraphicHighButton.x = Math.floor(mGameWidth * .5 - mGraphicLowButton.width * .5 );
			mGraphicHighButton.y = Math.floor(mGameHeight * .5 - mGraphicHighButton.height * .5 + 60);
		}


		private function graphicButtonOverHandler(e:MouseEvent):void
		{
			TweenMax.to(e.target, .6, {bevelFilter:{blurX:20, blurY:20, strength:1, angle:45, distance:5}});
		}

		private function graphicButtonOutHandler(e:MouseEvent):void
		{
			TweenMax.to(e.target, .6, {bevelFilter:{blurX:0, blurY:0, strength:0, angle:45, distance:0}});
		}

		
		private function addChildren():void
		{
			addChild(mBackground);
			addChild(mLogo);
			addChild(mGraphicLowButton);
			addChild(mGraphicHighButton);
		}
	}
}
