﻿package de.davidochmann.games.decypher 
{	
	/**
	 * @author MR.WUT4
	 */
	
	import flash.errors.IllegalOperationError;	 
	import de.davidochmann.games.decypher.graphics.Character;	
	import de.davidochmann.games.decypher.interfaces.ICharacter;	
	import de.davidochmann.games.decypher.Grid;
	 
	public class CharacterGrid extends Grid 
	{
		public function CharacterGrid()
		{
			super();
		}
		
		
		public function highlightAll(pCharacter:String):void
		{
			if(pCharacter.length > 1 || pCharacter.length == 0)
				throw new IllegalOperationError("character must have a length of one");
			
			var character:ICharacter;
			var height:uint = maxHeight();
			var currentRow:Array;
			
			for(var i:uint = 0; i < height; i++)
			{
				currentRow = row(i);
				
				for(var k:uint = 0; k < currentRow.length; k++)
				{
					character = ICharacter(currentRow[k]);
					
					if(character is Character && character.getCharacter() == pCharacter)
						Character(character).highlight();
					else if(character is Character)
						Character(character).unlight();
				}
			}
		}

		
		public function highlight(pXIndex:uint, pYIndex:uint):void
		{
			var char:ICharacter = getCharacter(pXIndex, pYIndex);
			
			if(char is Character)
			{
				Character(char).setActive(true);
				Character(char).update();
			}
			
			else return;
		}		

		public function unlight(pXIndex:uint, pYIndex:uint):void
		{
			var char:ICharacter = getCharacter(pXIndex, pYIndex);
			
			if(char is Character)
			{
				Character(char).setActive(false);
				Character(char).update();
			}
			
			else return;
		}

		
		public function setCharacter(pXIndex:uint, pYIndex:uint, pCharacter:ICharacter):void
		{
			setElement(pXIndex, pYIndex, pCharacter);		
		}
		
		public function getCharacter(pXIndex:uint, pYIndex:uint):ICharacter
		{
			return ICharacter(getElement(pXIndex, pYIndex));
		}
	}
}
