﻿package de.davidochmann.games.decypher 
{
	/**
	 * @author MR.WUT4
	 */

	import flash.errors.IllegalOperationError;

	public class StringConverter 
	{		
		private static var mCharacterList:Array = [{org:"a", rep:"A"}, {org:"b", rep:"B"},
												   {org:"c", rep:"C"}, {org:"d", rep:"D"},
											       {org:"e", rep:"E"}, {org:"f", rep:"F"},
												   {org:"g", rep:"G"}, {org:"h", rep:"H"},
												   {org:"i", rep:"I"}, {org:"j", rep:"J"},
												   {org:"k", rep:"K"}, {org:"l", rep:"L"},
												   {org:"m", rep:"M"}, {org:"n", rep:"N"},
												   {org:"o", rep:"O"}, {org:"p", rep:"P"},
												   {org:"q", rep:"Q"}, {org:"r", rep:"R"},
												   {org:"s", rep:"S"}, {org:"t", rep:"T"},
												   {org:"u", rep:"U"}, {org:"v", rep:"V"},
												   {org:"w", rep:"W"}, {org:"x", rep:"X"},
												   {org:"y", rep:"Y"}, {org:"z", rep:"Z"},
												   {org:"ü", rep:"Ü"}, {org:"ö", rep:"Ö"},
												   {org:"ä", rep:"Ä"}];

		public function StringConverter(){}
		
		
		public static function contains(pString:String):String
		{
			var current:String;
			var contains:String = "";
			
			for(var l:uint = 0; l < pString.length; l++)
			{
				current = pString.charAt(l);
			
				if(contains.search(current) == -1)
					contains += current;
				else
					continue;
			}
			
			return contains;
		}
		
		public static function shuffle(pString:String, pCharacterList:String, pSilentList:String):String
		{
			var randomPosition:uint;
			var current:String;
			var text:String = "";
			var character:String;
			var proceed:Boolean;
			var position:uint;
			
			while(randomPosition < 5)
				randomPosition = Math.random() * pCharacterList.length;
			
			for(var i:uint = 0; i < pString.length; i++)
			{
				proceed = true;
				current = pString.charAt(i);


				for(var j:uint = 0; j < pSilentList.length; j++)
				{
					
					if(current == pSilentList.charAt(j) || current == "\nr" || current == "\n" || current == "\r")
					{
						proceed = false;
						break;
					}
				}
				
				
				if(! proceed)
				{
					text += current;					
					continue;
				}
				
				
				for(var k:uint = 0; k < pCharacterList.length; k++)
				{
					if(pCharacterList.charAt(k) == current)
					{
						position = k;
						break;
					}
				}					
				
				character = pCharacterList.charAt((position + randomPosition) % pCharacterList.length);
				text += character;
			}
			
			return text;
		}

		
		public static function split(pString:String):Array
		{
			var list:Array = pString.split("\nr").join("|").split("\n").join("|").split("\r").join("|").split("|");
			return list;
		}
		
		public static function capitalize(pString:String):String
		{
			var string:String = "";
			var character:String;
			
			if(pString.length < 1)
				throw new IllegalOperationError("string must have at least one character");
						
			for(var i:int = 0; i < pString.length; i++)
			{	
				character = replace(pString.charAt(i));
				string    = string + character; 
			}
			
			return string;
		}
		
		private static function replace(pString:String):String
		{
			var character:String = pString;
			var original:String;
			var replacement:String;
					
			for(var i:int = 0; i < mCharacterList.length; i++)
			{
				original = mCharacterList[i].org;
				replacement = mCharacterList[i].rep;
				
				if(character == original)
					character = replacement;
			}
			
			return character;
		}
	}
}
