﻿package de.davidochmann.games.decypher 
{	
	/**
	 * @author MR.WUT4
	 */
	
	import de.davidochmann.games.decypher.events.TickerEvent;	
	import flash.events.EventDispatcher;	
	import flash.events.TimerEvent;	
	import flash.utils.Timer;	
	
	public class Ticker extends EventDispatcher 
	{		
		private var mInterval:uint;
		private var mTickerEnd:String;
		
		private var mTimer:Timer;
		private var mTime:String;
		
		private var mSeconds:uint;
		private var mMinutes:uint;
		private var mHours:uint;

		public function Ticker(pInterval:uint, pTickerEnd:String)
		{
			reset();
			
			setInterval(pInterval);
			setTickerEnd(pTickerEnd);			

			initTimer();
		}
		
		
		public function getTime():String
		{
			return mTime;
		}
		
		public function getSeconds():uint
		{
			return mSeconds;
		}

		public function getInterval():uint
		{
			return mInterval;
		}

		public function getTickerEnd():String
		{
			return mTickerEnd;
		}

		
		public function setInterval(pInterval:uint):void
		{
			mInterval = pInterval;
		}
		
		public function setTickerEnd(pEnd:String):void
		{
			mTickerEnd = pEnd;
		}


		public function start():void
		{
			mTimer.start();
		}

		public function stop():void
		{
			mTimer.stop();
		}
		
		public function reset():void
		{
			mSeconds = 0;
			mMinutes = 0;
			mHours   = 0;
			mTime    = "00:00:00";
		}

		
		private function initTimer():void
		{
			mTimer = new Timer(mInterval, 0);
			mTimer.addEventListener(TimerEvent.TIMER, timerTimerEvent);
		}
		
		
		private function timerTimerEvent(e:TimerEvent):void
		{
			calculateTime();
			increaseSeconds();
			
			dispatchEvent(new TickerEvent(TickerEvent.TICK, mTime));
			
			checkTickerEnd();
		}
		
		
		private function calculateTime():void
		{
			var seconds:String = checkLength(String(mSeconds % 61));
			var minutes:String = checkLength(String(mMinutes % 61));
			var hours:String   = checkLength(String(mHours % 61)); 
			
			mTime = hours + ":" + minutes + ":" + seconds;
		}

		private function increaseSeconds():void
		{
			mSeconds++;
			
			if(mSeconds >= (mMinutes + 1) * 60)
				mMinutes ++;
			
			if(mMinutes >= (mHours + 1) * 60)
				mHours ++;
		}
		
		private function checkLength(pString:String):String
		{
			var string:String = pString;
			
			if(string.length < 2)
				string = "0" + string;
			
			return string;
		}
		
		private function checkTickerEnd():void
		{
			if(mTime == mTickerEnd)
			{
				stop();
				dispatchEvent(new TickerEvent(TickerEvent.END, mTime));
			}
		}
	}
}
