package de.davidochmann.games.decypher.controls
{	
	/**
	 * @author MR.WUT4
	 */
	import flash.events.EventDispatcher;
	import de.davidochmann.games.decypher.events.ControlsEvent;	
	import flash.events.KeyboardEvent;	
	import flash.display.Stage;	

	public class Controls extends EventDispatcher 
	{
		private static var ENTER:uint = 13;
		private static var SPACE:uint = 32;
		private static var TAB:uint = 9;
		private static var ESCAPE:uint = 27;
		
		private static var UP:uint = 38;
		private static var DOWN:uint = 40;
		private static var LEFT:uint = 37;
		private static var RIGHT:uint = 39;
		
		private static var mInstance:Controls;
		private var mStage:Stage;
		
		
		public function Controls(pSingeltonEnforcer:SingeltonEnforcer){}
		
		public static function getInstance():Controls
		{
			if(! mInstance)
				mInstance = new Controls(new SingeltonEnforcer());
				
			return mInstance;	
		}
		
		public function initialize(pStage:Stage):void
		{
			setStage(pStage);
			initKeyboardEvents();
		}
		
		
		public function getStage():Stage
		{
			return mStage;
		}

		public function setStage(pStage:Stage):void
		{
			mStage = pStage;
		}
		
		
		private function initKeyboardEvents():void
		{
			mStage.addEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
		}
		
		private function keyDownHandler(e:KeyboardEvent):void
		{
			switch(e.keyCode)
			{
				case UP:
					dispatchEvent(new ControlsEvent(ControlsEvent.UP));
					break;

				case DOWN:
					dispatchEvent(new ControlsEvent(ControlsEvent.DOWN));
					break;
					
				case LEFT:
					dispatchEvent(new ControlsEvent(ControlsEvent.LEFT));
					break;
					
				case RIGHT:
					dispatchEvent(new ControlsEvent(ControlsEvent.RIGHT));
					break;

				case ENTER:
					dispatchEvent(new ControlsEvent(ControlsEvent.ENTER));
					break;
				
				case SPACE:
					dispatchEvent(new ControlsEvent(ControlsEvent.SPACE));
					break;
					
				case TAB:
					dispatchEvent(new ControlsEvent(ControlsEvent.TAB));
					break;
					
				case ESCAPE:
					dispatchEvent(new ControlsEvent(ControlsEvent.ESCAPE));
					break;					
			}
		}
	}
}

class SingeltonEnforcer{}
