﻿package de.davidochmann.games.decypher.events 
{	
	/**
	 * @author MR.WUT4
	 */

	import flash.events.Event;
	
	public class CharacterEvent extends Event 
	{
		public static var ACTIVE:String = "ACTIVE";
		public static var INACTIVE:String = "INACTIVE";
		public static var OVER:String = "OVER";
		public static var UP:String = "UP";
		
		private var character:String;
		private var highlight:Boolean;
		
		public function CharacterEvent(type:String,
									   character:String,
									   highlight:Boolean,
									   bubbles:Boolean = false, 
									   cancelable:Boolean = false)
		{
			super(type, bubbles, cancelable);
			
			setCharacter(character);
			setHighlight(highlight);
		}
	

		public function getCharacter():String
		{
			return character;
		}

		public function getHighlight():Boolean
		{
			return highlight;
		}

		
		public function setCharacter(pCharacter:String):void
		{
			character = pCharacter;
		}

		public function setHighlight(pHighlight:Boolean):void
		{
			highlight = pHighlight;
		}

		
		override public function clone():Event
		{
			return new CharacterEvent(type, character, highlight);
		}
		
		override public function toString():String
		{
			return formatToString("CharacterEvent", "type");
		}
	}
	
}
