﻿package de.davidochmann.games.decypher.events 
{	
	/**
	 * @author David Ochmann
	 */

	import de.davidochmann.games.decypher.graphics.Character;	
	import flash.events.Event;

	public class GridNavigatorEvent extends Event 
	{
		private var character:Character;
		private var xindex:uint;
		private var yindex:uint;
		
		public function GridNavigatorEvent(type:String,
										   character:Character,
										   xindex:uint,
										   yindex:uint,
										   bubbles:Boolean = false, 
										   cancelable:Boolean = false)
		{
			super(type, bubbles, cancelable);
			setCharacter(character);
			setXIndex(xindex);
			setYIndex(yindex);	
		}
		
		
		public function getCharacter():Character
		{
			return character;
		}

		public function getXIndex():uint
		{
			return xindex;
		}

		public function getYIndex():uint
		{
			return yindex;
		}

		
		public function setCharacter(pCharacter:Character):void
		{
			character = pCharacter;
		}

		public function setXIndex(pXIndex:uint):void
		{
			xindex = pXIndex;
		}

		public function setYIndex(pYIndex:uint):void
		{
			yindex = pYIndex;
		}

		
		override public function clone():Event
		{
			return new GridNavigatorEvent(type, character, xindex, yindex);
		}
		
		override public function toString():String
		{
			return formatToString("GridNavigator", "type");
		}
	}
}
