package de.davidochmann.games.decypher.graphics 
{	
	/**
	 * @author dochmann
	 */	
	
	import flash.errors.IllegalOperationError;	
	import flash.display.Graphics;	
	import flash.display.Sprite;
	
	public class BarDiagram extends Sprite 
	{
		private var mPercent:uint;
		private var mWidth:uint;
		private var mHeight:uint;
		private var mColor1:uint;
		private var mColor2:uint;
		
		private var mBackground:Sprite;		
		private var mForeground:Sprite;
		
		public function BarDiagram(pPercent:uint, 
								   pWidth:uint, 
								   pHeight:uint, 
								   pColor1:uint, 
								   pColor2:uint)
		{
			setPercent(pPercent);
			setWidth(pWidth);
			setHeight(pHeight);
			setColor1(pColor1);
			setColor2(pColor2);
		
			initBackground();
			initForeground();
	
			addChildren();
		}
		
		
		public function getPercent():uint
		{
			return mPercent;
		}

		public function getWidth():uint
		{
			return mWidth;		
		}
		
		public function getHeight():uint
		{
			return mHeight;
		}

		public function getColor1():uint
		{
			return mColor1;
		}

		public function getColor2():uint
		{
			return mColor2;
		}

		
		public function setPercent(pPercent:uint):void
		{
			if(pPercent > 100)
				throw new IllegalOperationError("pPercent cannot be higher than 100");
				
			mPercent = pPercent;
		}

		public function setWidth(pWidth:uint):void
		{
			mWidth = pWidth;
		}

		public function setHeight(pHeight:uint):void
		{
			mHeight = pHeight;
		}

		public function setColor1(pColor1:uint):void
		{
			mColor1 = pColor1;
		}

		public function setColor2(pColor2:uint):void
		{
			mColor2 = pColor2;
		}

		
		private function initBackground():void
		{
			mBackground = new Sprite();
			
			var canvas:Graphics = mBackground.graphics;
			
			canvas.beginFill(mColor1, 1);
			canvas.drawRect(0, 0, mWidth, mHeight);
			canvas.endFill();			
		}

		private function initForeground():void
		{
			mForeground = new Sprite();
			
			var canvas:Graphics = mForeground.graphics;
			var percent:uint = (mHeight / 100) * mPercent;
			
			canvas.beginFill(mColor2, 1);
			canvas.drawRect(0, mHeight - percent, mWidth, percent);
			canvas.endFill();
		}

		
		private function addChildren():void
		{
			addChild(mBackground);
			addChild(mForeground);
		}
	}
}
