﻿package de.davidochmann.games.decypher.graphics 
{	
	/**
	 * @author David Ochmann
	 */
	 
	import flash.display.DisplayObject;	
	import flash.display.Sprite;
	import de.davidochmann.games.decypher.Grid;	

	public class GridCreator extends Sprite 
	{
		private var mGrid:Grid;
		private var mElementWidth:uint;
		private var mElementHeight:uint;
		private var mElementSpace:uint;
		
		private var mContainer:Sprite;
		
		
		public function GridCreator(pGrid:Grid, pElementWidth:uint, pElementHeight:uint, pElementSpace:uint)
		{
			initContainer();
			
			setGrid(pGrid);
			setElementWidth(pElementWidth);
			setElementHeight(pElementHeight);
			setElementSpace(pElementSpace);
		}
		
		
		public function create():Sprite
		{
			var maxLength:uint;
			var collumn:Array;
			var element:DisplayObject;

			maxLength = mGrid.maxLength();
				
			for(var i:uint = 0; i < maxLength; i++)
			{
				collumn = mGrid.column(i);
				
				for(var j:uint = 0; j < collumn.length; j++)
				{
					if(mGrid.getElement(i, j) is DisplayObject)
					{
						element = DisplayObject(mGrid.getElement(i, j));
						element.x = i * (mElementWidth  + mElementSpace);
						element.y = j * (mElementHeight + mElementSpace);
						
						mContainer.addChild(element);
					}
				}
			}
			
			return mContainer;
		}

		public function grid():Sprite
		{
			return mContainer;
		}


		public function getGrid():Grid
		{
			return mGrid;
		}

		public function getElementWidth():uint
		{
			return mElementWidth;
		}

		public function getElementHeight():uint
		{
			return mElementHeight;
		}

		public function getElementSpace():uint
		{
			return mElementSpace;
		}
		
		
		public function setGrid(pGrid:Grid):void
		{
			mGrid = pGrid;
		}

		public function setElementWidth(pElementWidth:uint):void
		{
			mElementWidth = pElementWidth;
		}

		public function setElementHeight(pElementHeight:uint):void
		{
			mElementHeight = pElementHeight;
		}
		
		public function setElementSpace(pElementSpace:uint):void
		{
			mElementSpace = pElementSpace;
		}
		
		
		public function initContainer():void
		{
			mContainer = new Sprite();
		}
	}
}
