﻿package de.davidochmann.games.decypher.graphics
{	
	/**
	 * @author MR.WUT4
	 */
	import flash.display.Graphics;	
	
	import de.davidochmann.games.decypher.interfaces.ICharacter;	
	
	import flash.text.TextFieldAutoSize;		
	import flash.errors.IllegalOperationError;	
	import flash.text.TextField;	 
	import flash.text.TextFormat;	
	import flash.display.Sprite;	 

	public class SilentCharacter extends Sprite implements ICharacter
	{
		private var mCharacter:String;
		private var mTextFormat:TextFormat;
		private var mWidth:uint;
		private var mHeight:uint;
		
		private var mTextField:TextField;
		private var mContainer:Sprite;
		
		
		public function SilentCharacter(pCharacter:String, 
								 	    pTextFormat:TextFormat, 
							      		pWidth:uint, 
								 		pHeight:uint)
		{		
			setCharacter(pCharacter);
			setTextFormat(pTextFormat);
			setWidth(pWidth);
			setHeight(pHeight);
			
			initTextField();
			initContainer();
							
			addChildren();
		}
		
		
		public function text(pCharacter:String):void
		{
			setCharacter(pCharacter);
			mTextField.text = mCharacter;
			
			mTextField.x = mWidth  * .5 - mTextField.width  * .5;
			mTextField.y = mHeight * .5 - mTextField.height * .5;
		} 
	
	
		public function getCharacter():String
		{
			return mCharacter;	
		}

		public function getTextFormat():TextFormat
		{
			return mTextFormat;
		}

		public function getWidth():uint
		{
			return mWidth;
		}

		public function getHeight():uint
		{
			return mHeight;
		}

		
		public function setCharacter(pCharacter:String):void
		{
			if(pCharacter.length > 1 || pCharacter.length == 0)
				throw new IllegalOperationError("character must have a length of one");
			
			mCharacter = pCharacter;
		}
	
		public function setTextFormat(pTextFormat:TextFormat):void
		{
			mTextFormat = pTextFormat;
		}
		
		public function setWidth(pWidth:uint):void
		{
			mWidth = pWidth;
		}
		
		public function setHeight(pHeight:uint):void
		{
			mHeight = pHeight;
		}

		
		private function initTextField():void
		{
			mTextField = new TextField();
			
			mTextField.text = mCharacter;
			mTextField.defaultTextFormat = mTextFormat;
			
			mTextField.autoSize = TextFieldAutoSize.LEFT;
			mTextField.mouseEnabled = false;
			
			mTextField.x = mWidth  * .5 - mTextField.width  * .5;
			mTextField.y = mHeight * .5 - mTextField.height * .5;
		}

		private function initContainer():void
		{			
			mContainer = new Sprite();
			mContainer.addChild(mTextField);
			
			var canvas:Graphics = mContainer.graphics;
			
			canvas.beginFill(0xeeeeee);
			canvas.drawRect(0         , 0          , mWidth, mHeight);
			canvas.drawRect(0         , 0          , 1     , 1      );
			canvas.drawRect(mWidth - 1, 0          , 1     , 1      );
			canvas.drawRect(0         , mHeight - 1, 1     , 1      );
			canvas.drawRect(mWidth - 1, mHeight - 1, 1     , 1      );
			canvas.endFill();
		}

		private function addChildren():void
		{
			addChild(mContainer);
		}
	}
}
